"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
const vue = __importStar(require("@vue/language-core"));
const typescript_1 = require("@vue/typescript");
const externalFiles = new WeakMap();
const init = (modules) => {
    const { typescript: ts } = modules;
    const pluginModule = {
        create(info) {
            const virtualFiles = vue.createVirtualFiles(vue.createLanguages(info.languageServiceHost.getCompilationSettings(), getVueCompilerOptions(), ts));
            (0, typescript_1.decorateLanguageService)(virtualFiles, info.languageService, true);
            (0, typescript_1.decorateLanguageServiceHost)(virtualFiles, info.languageServiceHost, ts, ['.vue']);
            return info.languageService;
            function getVueCompilerOptions() {
                if (info.project.projectKind === ts.server.ProjectKind.Configured) {
                    const tsconfig = info.project.getProjectName();
                    return vue.createParsedCommandLine(ts, ts.sys, tsconfig).vueOptions;
                }
                else {
                    return vue.createParsedCommandLineByJson(ts, ts.sys, info.languageServiceHost.getCurrentDirectory(), {}).vueOptions;
                }
            }
        },
        getExternalFiles(project, updateLevel = -1) {
            if (
            // @ts-expect-error wait for TS 5.3
            updateLevel >= 1
                || !externalFiles.has(project)) {
                const oldFiles = externalFiles.get(project);
                const newFiles = (0, typescript_1.searchExternalFiles)(ts, project, ['.vue']);
                externalFiles.set(project, newFiles);
                if (oldFiles) {
                    refreshDiagnosticsIfNeeded(project, oldFiles, newFiles);
                }
            }
            return externalFiles.get(project);
        },
    };
    return pluginModule;
};
function refreshDiagnosticsIfNeeded(project, oldExternalFiles, newExternalFiles) {
    let dirty = oldExternalFiles.length !== newExternalFiles.length;
    if (!dirty) {
        const set = new Set(oldExternalFiles);
        for (const file of newExternalFiles) {
            if (!set.has(file)) {
                dirty = true;
                break;
            }
        }
    }
    if (dirty) {
        project.refreshDiagnostics();
    }
}
module.exports = init;
//# sourceMappingURL=index.js.map